# bestimme abstand zwichen primzahlen

# import
import matplotlib.pyplot as plot
from math import log

# constants
N = 10**8
SCALE = 1000
INTER = int(N/SCALE)

PRIME = [True for i in range(0, N)]

print('calculate all prime up to', N)

for i in range(2, N):
    if PRIME[i]:
        for j in range(i*i, N, i):
            PRIME[j] = False

    if i % (N / 50) == 0:
        print('.', end='')

print('')


# durchschnitt pro intervall
x_axis = range(0, N, INTER)
add = [0 for i in x_axis]
count = [0 for i in x_axis]
mean = [0 for i in x_axis]
last_prime = 2

for i in range(3, N):
    if PRIME[i]:
        diff = i - last_prime
        interval = int(i / INTER)
        add[interval] += diff
        count[interval] += 1
        last_prime = i

for i in range(len(mean)):
    if count[i]:
        mean[i] = add[i] / count[i]

log_data = [0] + [log(x) for x in x_axis[1:]]

# prepare visual
ax = plot.figure().add_subplot(111)
ax.set_xlim([0, N])
ax.set_ylim([0, 50])

ax.set_xlabel('n')
ax.set_ylabel('Durchschnittlicher Abstand im Intervall')

ax.plot(x_axis, mean, '-')
ax.plot(x_axis, log_data, '-')


plot.show()
